#!/bin/bash
#
# Alexey Sidorin (c) 2015
#
# For MongoDB 3.0.3 # version 1.0
#
# dsmoke@ukr.net
#
PT=`dirname $0`

source $PT/settings


BC='/usr/bin/bc'

metric()
{
    metric=` echo $2`
    num=`echo $1`

    if [ "$metric" == 'k' ]; then
        RESULT=$( echo "$num * 1024" | $BC  )
    fi

    if [ "$metric" == 'G' ]; then
        RESULT=$( echo "$num * 1024 * 1024 * 1024" | $BC  )
    fi

    if [ "$metric" == 'M' ]; then
        RESULT=$( echo "$num * 1024 * 1024" | $BC  )
    fi

    if [ "$metric" == 'b' ]; then
        RESULT=$num
    fi
    echo $RESULT
}

RES=`$PATH_MONGOSTAT --host $HOST --port $PORT -u $USERNAME -p $PASSWORD -n1 --authenticationDatabase $DB --noheaders`


PID=`ps aux| grep -w "mongos" | grep -v grep`



INSERT=`echo $RES | awk {'print $1'} | sed 's/\*//'`
QUERY=`echo $RES | awk {'print $2'} | sed 's/\*//'`
UPDATE=`echo $RES | awk {'print $3'} | sed 's/\*//'`
DELETE=`echo $RES | awk {'print $4'} | sed 's/\*//'`
GETMORE=`echo $RES | awk {'print $5'} | sed 's/\*//'`

COMMAND=`echo $RES | awk {'print $6'}`
COMMAND_LOCAL=`echo $COMMAND | sed -r 's/\|[0-9]+//'`
COMMAND_REPLICATED=`echo $COMMAND | sed -r 's/[0-9]+\|//'`

DIRTY=`echo $RES | awk {'print $7'}`
USED=`echo $RES | awk {'print $8'}`
FLUSHES=`echo $RES | awk {'print $9'}`

if [ "$PID" ]; then
    VSIZE=`echo $RES | awk {'print $8'}`
else
    VSIZE=`echo $RES | awk {'print $10'}`
fi

VSIZE_METRIC=`echo $VSIZE | sed -r 's/[0-9]|\.//g'`
VSIZE_NUM=`echo $VSIZE | sed -r 's/[a-zA-Z]//g'`
vsize=$(metric $VSIZE_NUM $VSIZE_METRIC)


if [ "$PID" ]; then
    RES2=`echo $RES | awk {'print $9'}`
else
    RES2=`echo $RES | awk {'print $11'}`
fi

RES_METRIC=`echo $RES2 | sed -r 's/[0-9]|\.//g'`
RES_NUM=`echo $RES2 | sed -r 's/[a-zA-Z]//g'`
res=$(metric $RES_NUM $RES_METRIC)


QR=`echo $RES | awk {'print $12'} | sed -r 's/\|[0-9]+//'`
QW=`echo $RES | awk {'print $12'} | sed -r 's/[0-9]+\|//'`

AR=`echo $RES | awk {'print $13'} | sed -r 's/\|[0-9]+//'`
AW=`echo $RES | awk {'print $13'} | sed -r 's/[0-9]+\|//'`

NETIN=`echo $RES | awk {'print $14'}`
NETIN_METRIC=`echo $NETIN | sed -r 's/[0-9]|\.//g'`
NETIN_NUM=`echo $NETIN | /bin/sed -r 's/[a-zA-Z]//g'`
netin=$(metric $NETIN_NUM $NETIN_METRIC)

NETOUT=`echo $RES | awk {'print $15'}`
NETOUT_METRIC=`echo $NETOUT | sed -r 's/[0-9]|\.//g'`
NETOUT_NUM=`echo $NETOUT | sed -r 's/[a-zA-Z]//g'`
netout=$(metric $NETOUT_NUM $NETOUT_METRIC)

CONN=`echo $RES | awk {'print $16'}`

echo "insert $INSERT"
echo "query $QUERY"
echo "update $UPDATE"
echo "delete $DELETE"
echo "getmore $GETMORE"
echo "command_local $COMMAND_LOCAL"
echo "command_replicated $COMMAND_REPLICATED"
if [ "$PID" ]; then
    echo "flushes $DIRTY"
else
    echo "dirty $DIRTY"
fi

if [ ! "$PID" ]; then
    echo "used $USED"
    echo "flushes $FLUSHES"
fi
echo "vsize $vsize"
echo "res $res"
echo "qr $QR"
echo "qw $QW"
echo "ar $AR"
echo "aw $AW"
echo "netin $netin"
echo "netout $netout"
echo "conn $CONN"
